<?php 

/*
*	Primjer PHP skripte za autentikaciju korisnika uporabom programskog alata simpleSAMLphp
*	Vrijeme zadnje izmjene:	10.10.2013.
*	Autor:	Dubravko Voncina
*	Mail:	team@aaiedu.hr
*
*******************************************************************************************/


/*
*    Putanja do datoteke _autoload.php u direktoriju u kojem je instaliran simpleSAMLphp:
*
*****************************************************************************************/
require_once('/var/www/simplesamlphp/lib/_autoload.php');


/*
*	U nastavku treba odkomentirati jednu od sljedece tri linije, ovisno o tome
*	koristi li aplikacija za autentikaciju testni fed-lab SSO servis, produkcijski 
*	AAI@EduHr SSO servis ili proxy servis za autentikaciju korisnika putem 
*	drustvenih mreza:
*
***********************************************************************************/
$as = new SimpleSAML_Auth_Simple('fedlab-sp');		// testni, fed-lab SSO
// $as = new SimpleSAML_Auth_Simple('default-sp');	// produkcijski SSO servis
// $as = new SimpleSAML_Auth_Simple('proxy-sp');	// proxy za drustvene mreze


$as->requireAuth();
$attributes = $as->getAttributes();
session_start(); 

/*
*	Recimo da za rad aplikacija koristi sljedece session varijable 
*	u kojima su pohranjeni korisnicki podaci:
*
*		$_SESSION['username']		-> korisnicka oznaka
*		$_SESSION['mail']			-> elektronicka adresa
*		$_SESSION['firstname']		-> ime
*		$_SESSION['surname']		-> prezime
*
******************************************************************/


if( !isset( $_SESSION['username'] ) ){
	$_SESSION['mail'] = "";
	$_SESSION['firstname'] = "";
	$_SESSION['surname'] = "";
	
	if( isset($attributes['hrEduPersonUniqueID']) ){

		/*
		*	Ako se korisnik autenticirao putem testnog ili produkcijskog AAI@EduHr SSO servisa:
		*
		***************************************************************************************/

		$_SESSION['username'] = $attributes['hrEduPersonUniqueID'][0];

		if( isset( $attributes['mail'] ) ){
			$_SESSION['mail'] = $attributes['mail'][0];
		}

		if( isset( $attributes['givenName'] ) ){
			$_SESSION['firstname'] = $attributes['givenName'][0];
		}

		if( isset( $attributes['sn'] ) ){
			$_SESSION['surname'] = $attributes['sn'][0];
		}
	}
	else if( isset($attributes['facebook_targetedID']) ){

		/*
		*	Ako se korisnik autenticirao putem Facebooka koristeci proxy servis za autentikaciju putem drustvenih mreza:
		*
		****************************************************************************************************************/ 

		$_SESSION['username'] = $attributes['facebook_targetedID'][0];

		if( isset( $attributes['facebook.first_name'] ) ){
			$_SESSION['firstname'] = $attributes['facebook.first_name'][0];
		}

		if( isset( $attributes['facebook.last_name'] ) ){
			$_SESSION['surname'] = $attributes['facebook.last_name'][0];
		}
	}
	else if( isset($attributes['openid'])){

		/*
		*	Ako se korisnik autenticirao putem Googlea koristeci proxy servis za autentikaciju putem drustvenih mreza:
		*
		**************************************************************************************************************/
		
		$_SESSION['username'] = $attributes['openid'][0];

		if( isset( $attributes['http://axschema.org/contact/email'] ) ){
			$_SESSION['mail'] = $attributes['http://axschema.org/contact/email'][0];
		}

		if( isset( $attributes['http://axschema.org/namePerson/first'] ) ){
			$_SESSION['firstname'] = $attributes['http://axschema.org/namePerson/first'][0];
		}

		if( isset( $attributes['http://axschema.org/namePerson/last'] ) ){
			$_SESSION['surname'] = $attributes['http://axschema.org/namePerson/last'][0];
		}
	}
	else if( isset($attributes['twitter_targetedID'])){

		/*
		*	Ako se korisnik autenticirao putem Twittera koristeci proxy servis za autentikaciju putem drustvenih mreza:
		*
		***************************************************************************************************************/

		$_SESSION['username'] = $attributes['twitter_targetedID'][0];

		if( isset( $attributes['twitter.name'] ) ){
			$_SESSION['firstname'] = $attributes['twitter.name'][0];
		}
	}
	else if( isset($attributes['linkedin_targetedID']) ){

		/*
		*	Ako se korisnik autenticirao putem LinkedIna koristeci proxy servis za autentikaciju putem drustvenih mreza:
		*
		****************************************************************************************************************/

		$_SESSION['username'] = $attributes['linkedin_targetedID'][0];

		if( isset( $attributes['linkedin.firstName'] ) ){
			$_SESSION['firstname'] = $attributes['linkedin.firstName'][0];
		}

		if( isset( $attributes['linkedin.lastName'] ) ){
			$_SESSION['surname'] = $attributes['linkedin.lastName'][0];
		}
	}

	if( isset( $_SESSION['username'] ) ){
		echo '<html><head><title>AAI@EduHr Auth Demo</title><meta http-equiv="Content-Type" content="text/html; charset=utf-8"></head><body>';
		echo "User is successfuly authenticated and following user data was retrieved:<br><br>";
                echo "User ID: <strong>".$_SESSION['username']."</strong><br><br>";
                echo "Name: <strong>".$_SESSION['firstname']." ".$_SESSION['surname']."</strong><br><br>";
                echo "Email address: <strong>".$_SESSION['mail']."</strong><br><br>";
                echo "<a href='logout.php'>Logout</a>";
		echo '</body></html>';
	}
	else{
		echo '<html><head><title>AAI@EduHr Auth Demo</title><meta http-equiv="Content-Type" content="text/html; charset=utf-8"></head><body>';
		echo "Authentication service did not provide unique UserID!";
                echo "<br><br>";
		echo "<a href='logout.php'>Logout</a>";
		echo '</body></html>';
	}

}
else{

	/*
	*	Ako je korisnik vec autenticiran, tj. postavljene su odgovarajuce vrijednosti session varijabli, nastavi s radom:
	*
	*********************************************************************************************************************/

	echo '<html><head><title>AAI@EduHr Auth Demo</title><meta http-equiv="Content-Type" content="text/html; charset=utf-8"></head><body>';
        echo "User is already authenticated and following user data was retrieved:<br><br>";
        echo "User ID: <strong>".$_SESSION["username"]."</strong><br><br>";
        echo "Name: <strong>".$_SESSION['firstname']." ".$_SESSION['surname']."</strong><br><br>";
        echo "Email address: <strong>".$_SESSION['mail']."</strong><br><br>";
        echo "<a href='logout.php'>Logout</a>";
	echo '</body></html>';
}

?>
