<?php

/*
*   Primjer PHP skripte za odjavu korisnika uporabom programskog alata simpleSAMLphp
*   Vrijeme zadnje izmjene: 10.10.2013.
*   Autor:	Dubravko Voncina
*   Mail:	team@aaiedu.hr
*
************************************************************************************/


/*
*    Putanja do datoteke _autoload.php u direktoriju u kojem je instaliran simpleSAMLphp:
*
*****************************************************************************************/
require_once('/var/www/simplesamlphp/lib/_autoload.php');


/*
*   U nastavku treba odkomentirati jednu od sljedece tri linije, ovisno o tome
*   koristi li aplikacija za autentikaciju testni fed-lab SSO servis, produkcijski
*   AAI@EduHr SSO servis ili proxy servis za autentikaciju korisnika putem
*   drustvenih mreza:
*
***********************************************************************************/
$as = new SimpleSAML_Auth_Simple('fedlab-sp');     // testni, fed-lab SSO
// $as = new SimpleSAML_Auth_Simple('default-sp');  // produkcijski SSO servis
// $as = new SimpleSAML_Auth_Simple('proxy-sp');    // proxy za drustvene mreze


if( $as->isAuthenticated() ) {
	$as->logout( array( 'ReturnTo' => currentPageURL() ) );
}
else{
	session_start();
	session_destroy();
	echo '<html><head><title>AAI@EduHr Auth Demo</title><meta http-equiv="Content-Type" content="text/html; charset=utf-8"></head><body>';
	echo 'You have successfuly logged out. Click <a href="index.php">HERE</a> to authenticate again.';
	echo '</body></html>';
}

function currentPageURL() {
	$pageURL = 'http';
	if ($_SERVER["HTTPS"] == "on") {$pageURL .= "s";}
	$pageURL .= "://";
	if ($_SERVER["SERVER_PORT"] != "80") {
		$pageURL .= $_SERVER["SERVER_NAME"].":".$_SERVER["SERVER_PORT"].$_SERVER["REQUEST_URI"];
	}
	else{
		$pageURL .= $_SERVER["SERVER_NAME"].$_SERVER["REQUEST_URI"];
	}
 	return $pageURL;
}

?>
